package kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.like

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.like.QCreatorCommunityLike.creatorCommunityLike
import org.springframework.data.jpa.repository.JpaRepository

interface CreatorCommunityLikeRepository :
    JpaRepository<CreatorCommunityLike, Long>, CreatorCommunityLikeQueryRepository {
    fun findByIdAndMemberId(id: Long, memberId: Long): CreatorCommunityLike?
}

interface CreatorCommunityLikeQueryRepository {
    fun totalCountCommunityPostLikeByPostId(postId: Long): Int
}

class CreatorCommunityLikeQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : CreatorCommunityLikeQueryRepository {
    override fun totalCountCommunityPostLikeByPostId(postId: Long): Int {
        return queryFactory
            .select(creatorCommunityLike.id)
            .from(creatorCommunityLike)
            .where(
                creatorCommunityLike.isActive.isTrue
                    .and(creatorCommunityLike.creatorCommunity.id.eq(postId))
            )
            .fetch()
            .size
    }
}
